import  java.io.*;
import  java.util.Scanner;

class binary {

  public static void printArray(int a[]) {
	int i;
        System.out.print("[ ");
	for(i = 0; i < a.length; i++)
	    System.out.print(a[i] + " ");
	System.out.println("]");
  }
    
    public static void printSubArray(int a[],int l,int r) {
	int i;
        System.out.print("[ ");
	for(i = 0; i < a.length; i++)
	    if (i >= l && i <= r) 
	       System.out.print(a[i] + " ");
            else
	       System.out.print("   ");
	System.out.println("]");
  }
    
    
  public static int[] readArray() {
    Scanner in = new Scanner(System.in);    
    System.out.print("Length of the array: ");
    int size = in.nextInt();
    int[] a = new int[size];
    for (int i = 0; i < size; i++) {
       System.out.print("Insert the "+(i+1)+"-th value: ");
       a[i] = in.nextInt();
    }
    return a;   
  } 

    public static int binary(int a[], int v) {
	int l = 0,r = a.length-1, m = (l+r)/2;
System.out.print("l="+a[l]+" r="+a[r]+" pivot="+a[m]+ " ");
printSubArray(a,l,r); 
	while(a[m] != v && l <= r) {
	    if(a[m] < v) 
              l = m+1; 
            else 
              r = m-1;
	    m = (l+r)/2;
System.out.print("l="+a[l]+" +="+a[r]+" pivot="+a[m]+ " ");
printSubArray(a,l,r);
	}  
	if(l <= r) return m+1; else return -1;
    } 


public static void main(String args[]) {
    Scanner in = new Scanner(System.in);
    int a[] = readArray();
    printArray(a);
    int value = -1;
    int res = -1;
    do {
      System.out.print("Input the value to search (-1 to stop): ");
      value = in.nextInt();
      if (value >= 0) {
         res = binary(a,value);
         if (res == -1)
            System.out.println("value not found");
         else
    	    System.out.println("value found in position "+res);
      }
    } while (value >= 0);
  }


}
