import  java.io.*;
import  java.util.Scanner;

class mergeBug1 {

  public static void printArray(int a[]) {
	int i;
        System.out.print("[ ");
	for(i = 0; i < a.length; i++)
	    System.out.print(a[i] + " ");
	System.out.println("]");
  }
    
    public static void printSubArray(int a[],int l,int r) {
	int i;
        System.out.print("[ ");
	for(i = 0; i < a.length; i++)
	    if (i >= l && i <= r) 
	       System.out.print(a[i] + " ");
            else
	       System.out.print("   ");
	System.out.println("]");
  }
    
    
  public static int[] readArray() {
    Scanner in = new Scanner(System.in);    
    System.out.print("Length of the array: ");
    int size = in.nextInt();
    int[] a = new int[size];
    for (int i = 0; i < size; i++) {
       System.out.print("Insert the "+(i+1)+"-th value: ");
       a[i] = in.nextInt();
    }
    return a;   
  } 

    public static int[] merge(int a[], int b[]) {
	  int[] c = new int[a.length+b.length];
	  for (int i=0,j=0,k=0;k<a.length+b.length;k++) {
	    if (a[i]<b[j]) {
	      c[k]=a[i];
	      i++;
	    }
	    else   {
	      c[k]=b[j];
	      j++;
	    }
	  }
          return c;
    } 


public static void main(String args[]) {
    Scanner in = new Scanner(System.in);
    int a[] = readArray();
    printArray(a);
    int b[] = readArray();
    printArray(b);
    int c[] = merge(a,b);
    System.out.println("The merged array is:");
    printArray(c);
  }
}
