import  java.io.*;
import  java.util.Scanner;

class mergesort {

  public static void printArray(int a[]) {
	int i;
        System.out.print("[ ");
	for(i = 0; i < a.length; i++)
	    System.out.print(a[i] + " ");
	System.out.println("]");
  }
    
    public static void printSubArray(int a[],int l,int r) {
	int i;
        System.out.print("[ ");
	for(i = 0; i < a.length; i++)
	    if (i >= l && i <= r) 
	       System.out.print(a[i] + " ");
            else
	       System.out.print("   ");
	System.out.println("]");
  }
    
    
  public static int[] readArray() {
    Scanner in = new Scanner(System.in);    
    System.out.print("Length of the array: ");
    int size = in.nextInt();
    int[] a = new int[size];
    for (int i = 0; i < size; i++) {
       System.out.print("Insert the "+(i+1)+"-th value: ");
       a[i] = in.nextInt();
    }
    return a;   
  } 

    public static void copyArray(int c[], int a[], int l) {
	for (int i = 0; i < c.length; i++) {
	    a[i+l] = c[i];
    }
  } 

    public static int[] merge(int a[],int l1,int r1,int l2,int r2) {
	  int n1 = r1-l1+1;
	  int n2 = r2-l2+1;
	  int[] c = new int[n1+n2];
	  for (int i=l1,j=l2,k=0;k<n1+n2;k++) {
	    if (j>r2 || (i<=r1 && a[i]<a[j])) {
	      c[k]=a[i];
	      i++;
	    }
	    else   {
	      c[k]=a[j];
	      j++;
	    }
	  }
          return c;
    } 

    public static void mergesortRec(int a[],int l,int r) {
	if (r-l>0) {
	    int m = (l+r)/2;
            mergesortRec(a,l,m);
            mergesortRec(a,m+1,r);
            int[] c = merge(a,l,m,m+1,r);
            copyArray(c,a,l);
	}
System.out.print("After sorting a["+(l+1)+","+(r+1)+"]: ");
printArray(a);
    }

    public static void mergesort(int a[]) {
        mergesortRec(a,0,a.length-1);
    }

public static void main(String args[]) {
    Scanner in = new Scanner(System.in);
    int a[] = readArray();
    printArray(a);
    // int b[] = readArray();
    // printArray(b);

    // copyArray(a,b,2);
    // printArray(b);

    mergesort(a);
    printArray(a);

  }
}
